﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GaCa
{
	class CA
	{
		
		public string Rule { get; set; }
		public CASettings Settings { get; set; }

		public CA(string rule)
		{
			this.Rule = rule;
			this.Settings = new CASettings();
		}

		public CA(string rule, CASettings settings)
		{
			this.Rule = rule;
			this.Settings = settings;
		}

		public CA(CASettings settings)
		{
			StringBuilder sbRule = new StringBuilder();
			int length = (int)Tools.Pow(settings.StatesPerCell, settings.Neighborhood);
			for (int i = 0; i < length; i++)
				//sbRule.Append(i % settings.StatesPerCell);
				sbRule.Append(Tools.Random.Next(settings.StatesPerCell));

			this.Rule = sbRule.ToString();

			this.Settings = settings;
		}

		//public void UpdateSize(int size)
		//{			
		//    settings.Size = size;
		//    if (size < Init.Length)
		//        Init = Init.Substring(0, size);
		//    else
		//        for (int i = Init.Length; i < size; i++)
		//            //Init += i % settings.StatesPerCell;
		//            Init += random.Next(settings.StatesPerCell);
		//}

		//public void UpdateStatesPerCell(int statesPerCell)
		//{
		//    settings.StatesPerCell = statesPerCell;
		//    //UpdateSize(settings.Size);
		//    StringBuilder sbRule = new StringBuilder();
		//    int length = (int)Tools.Pow(statesPerCell, settings.Neighborhood);
		//    for (int i = 0; i < length; i++)
		//        //sbRule.Append(i % statesPerCell);
		//        sbRule.Append(random.Next(statesPerCell));
		//    this.Rule = sbRule.ToString();
		//}

		//public void UpdateNeighborhood(int neighborhood)
		//{
		//    settings.Neighborhood = neighborhood;
		//    StringBuilder sbRule = new StringBuilder();
		//    int length = (int)Tools.Pow(settings.StatesPerCell, neighborhood);
		//    for (int i = 0; i < length; i++)
		//        //sbRule.Append(i % settings.StatesPerCell);
		//        sbRule.Append(random.Next(settings.StatesPerCell));
		//    this.Rule = sbRule.ToString();
		//}

		//public void Initialize(Settings settings)
		//{
			//this.settings = settings;

			//StringBuilder sbRule = new StringBuilder();
			//int length = (int)Tools.Pow(settings.StatesPerCell, settings.Neighborhood);
			//for (int i = 0; i < length; i++)
			//    //sbRule.Append(i % settings.StatesPerCell);
			//    sbRule.Append(random.Next(settings.StatesPerCell));

			//StringBuilder sbInit = new StringBuilder();
			//for (int i = 0; i < settings.Size; i++)
			//    //sbInit.Append(i % settings.StatesPerCell);
			//    sbInit.Append(random.Next(settings.StatesPerCell));

			//this.Rule = sbRule.ToString();
			//this.Init = sbInit.ToString();

		//    if (Rule == null)
		//    {
		//        Console.WriteLine("hat");
		//    }

		//}

		//public CA Copy()
		//{
		//    return new CA(tthis.Rule);
		//}

		//public string GetState()
		//{
		//    return machineState;
		//}

		public override string ToString()
		{
			return String.Format("{0} ({1})", Rule, Tools.BaseToDecimal(Rule, Settings.StatesPerCell));
		}

	}
}
