﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GaCa
{
	class Phenotype
	{
		//public string Init { get; set; }
		//public string Rule { get; set; }
		public CA Genotype { get; set; }
		public List<string> States { get; set; }
		//public List<int> PrePeriodicPath { get; set; }
		//public List<int> PeriodicPath { get; set; }
		public List<int> Interpretations { get; set; }
		public List<int> Magnitudes { get; set; }
		public List<double> Variables { get; set; }
		//double Fitness { get; set; }

		public int PrePeriodicLength { get; set; }
		public int PeriodicLength { get; set; }

		public List<int> HalfMagnitudes
		{
			get
			{
				return Magnitudes.GetRange(0, Magnitudes.Count / 2);
			}
		}

		public List<int> PeriodicPath 
		{ 
			get 
			{ 
				return Interpretations.GetRange(PrePeriodicLength, PeriodicLength);
			}
		}

		public override string ToString()
		{
			StringBuilder sb = new StringBuilder();
			//sb.AppendLine(String.Format("Pre-periodic path ({0}):", PrePeriodicPath.Count));
			//foreach (ulong i in PrePeriodicPath)
			//    sb.Append(i).Append("\t");
			//sb.AppendLine().AppendLine(String.Format("Periodic path ({0}):", PeriodicPath.Count));
			//foreach (ulong i in PeriodicPath)
			//    sb.Append(i).Append("\t");
			//sb.AppendLine().AppendLine(String.Format("Magnitudes ({0}):", Magnitudes.Count));
			//foreach (ulong i in Magnitudes)
			//    sb.Append(i).Append("\t");
			return sb.ToString();
		}
	}
}
