﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GaCa
{
	class ESSettings
	{
		public List<double> TargetVariables { get; set; }
		public List<int> TargetGraph { get; set; }
		public int ClonesPerCandidate { get; set; }
		public double MutationRate { get; set; }
		public VariableFitness.Comparison FitnessType { get; set; }
		public int FitnessDecimals { get; set; }

		public string InitialState { get; set; }
		public string FinalState { get; set; }
		public int DevelopmentSteps { get; set; } // including initial
		public int MaxGenerations { get; set; }

		//public int CaTime { get; set; }
		//public string CaInit { get; set; }

		public string I1 { get; set; }
		public string I2 { get; set; }
		public string I3 { get; set; }
		public string I4 { get; set; }
		public string I5 { get; set; }
		public List<double> T1 { get; set; }
		public List<double> T2 { get; set; }
		public List<double> T3 { get; set; }
		public List<double> T4 { get; set; }
		public List<double> T5 { get; set; }
	}
}
