﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GaCa
{
    class Transition
    {
		private Dictionary<string, char> transitions;
		CASettings settings;

		public Transition(CA ca)
		{
			settings = ca.Settings;
			this.transitions = new Dictionary<string, char>();

			int n = ca.Rule.Length;
			//for (int i = ca.Rule.Length - 1; i >= 0; i--)
			for(int i = 0; i < n; i++)
			{
				string nBase = Tools.DecimalToBase(n - i - 1, ca.Settings.StatesPerCell, ca.Settings.Neighborhood);
				transitions.Add(nBase, ca.Rule[i]);
			}
		}

		//public void Update(string rule)
		//{
		//    for (int i = 0; i < rule.Length; i++)
		//    {
		//        string key = transitions.ElementAt(i).Key;
		//        transitions[key] = rule[i];
		//    }
		//}

        public char NextState(string conf)
        {
			return transitions[conf];
        }

    }
}
