﻿//using System;
//using System.Collections.Generic;
//using System.Linq;
//using System.Text;

//namespace GaCa
//{
//    class TwoDimensionalCA// : CA
//    {
//        private int[][] machineState;
//        private RuleSet2D ruleSet;
//        private Size size;
//        private int time;
//        private List<int> machineOutputs;
//        private int windowSize;
//        private Random random;

//        public TwoDimensionalCA(Size size, RuleSet2D rules)
//        {
//            this.machineState = new int[size.Height][];
//            for (int i = 0; i < size.Height; i++)
//                machineState[i] = new int[size.Width];
//            this.ruleSet = rules;
//            this.size = size;
//            this.windowSize = 1000;
//            this.machineOutputs = new List<int>();
//            this.machineOutputs.Add(Convert(""));
//            this.time = 0;
//            this.random = new Random();
//        }

//        public void Run()
//        {
//            for (int i = 0; i < windowSize; i++)
//                Step();
//        }

//        public void Step()
//        {
//            int[][] nextMachineState = new int[size.Height][];
//            for (int y = 0; y < size.Height; y++)
//            {
//                nextMachineState[y] = new int[size.Width];
//                for (int x = 0; x < size.Width; x++)
//                {
//                    int signalState = machineState[y][x];
//                    int neighbours = LiveNeighboursOf(new Position(x, y));
//                    nextMachineState[y][x] = ruleSet.Next(signalState, neighbours);
//                }
//            }
//            time++;
//            this.machineState = nextMachineState;

//            this.machineOutputs.Add(Convert(""));
//            if (machineOutputs.Count > windowSize)
//                machineOutputs.RemoveAt(0);
//        }

//        public int LiveNeighboursOf(Position p)
//        {
//            int neighbours = 0;
//            for (int y = p.Y - 1; y <= p.Y + 1; y++)
//            {
//                for (int x = p.X - 1; x <= p.X + 1; x++)
//                {
//                    int nX = (x + size.Width) % size.Width;
//                    int nY = (y + size.Height) % size.Height;
//                    neighbours += machineState[nY][nX];
//                }
//            }
//            return neighbours - machineState[p.Y][p.X];
//        }

//        public void Randomize()
//        {
//            Reset();
//            for (int y = 0; y < size.Height; y++)
//            {
//                for (int x = 0; x < size.Width; x++)
//                {
//                    machineState[y][x] = random.NextDouble() > 0.5 ? 1 : 0;
//                }
//            }
//        }

//        public void Reset()
//        {
//            machineState = new int[size.Height][];
//            for (int i = 0; i < size.Height; i++)
//                machineState[i] = new int[size.Width];
//            machineOutputs = new List<int>();
//            machineOutputs.Add(Convert(""));
//        }

//        public int GetSignalState(Position p)
//        {
//            return machineState[p.Y][p.X];
//        }

//        public void SetSignalState(Position p, int signalState)
//        {
//            machineState[p.Y][p.X] = signalState;
//        }

//        public Size GetSize()
//        {
//            return size;
//        }

//        public int GetTime()
//        {
//            return time;
//        }

//        public int GetOutput()
//        {
//            return machineOutputs[machineOutputs.Count - 1];
//        }

//        public int[] GetOutputs()
//        {
//            return machineOutputs.ToArray();
//        }

//        public int Convert(string s)
//        {
//            int dec = 0;
//            for (int y = 0; y < size.Height; y++)
//            {
//                for (int x = 0; x < size.Width; x++)
//                {
//                    dec += machineState[y][x];
//                }
//            }
//            return dec;
//        }

//        public override string ToString()
//        {
//            return "";// machineState.Dump(size.Height);
//        }


//    }
//}
